//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Server.BinaryTransferTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Echo Binary Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBinaryValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.BinaryDto _binaryValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBinaryValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="binaryValue">The Binary value to be returned.</param>
        public EchoBinaryValueRequestDto(System.IO.Stream binaryValue, Tecan.Sila2.IBinaryStore store)
        {
            BinaryValue = new Tecan.Sila2.BinaryDto(binaryValue, store);
        }
        
        /// <summary>
        /// The Binary value to be returned.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BinaryDto BinaryValue
        {
            get
            {
                return _binaryValue;
            }
            set
            {
                _binaryValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(BinaryValue, "binaryValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(BinaryValue, "binaryValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Binary Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBinaryValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.BinaryDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBinaryValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedValue">The received Binary value transmitted in the same way it has been received.</param>
        public EchoBinaryValueResponseDto(System.IO.Stream receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.BinaryDto(receivedValue, store);
        }
        
        /// <summary>
        /// The received Binary value transmitted in the same way it has been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BinaryDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Binaries Observably command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBinariesObservablyRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private System.Collections.Generic.List<Tecan.Sila2.BinaryDto> _binaries;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBinariesObservablyRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="binaries">List of binaries to echo</param>
        public EchoBinariesObservablyRequestDto(System.Collections.Generic.ICollection<System.IO.Stream> binaries, Tecan.Sila2.IBinaryStore store)
        {
            Binaries = Tecan.Sila2.DtoExtensions.Encapsulate(binaries, Tecan.Sila2.BinaryDto.Create, store);
        }
        
        /// <summary>
        /// List of binaries to echo
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public System.Collections.Generic.List<Tecan.Sila2.BinaryDto> Binaries
        {
            get
            {
                return _binaries;
            }
            set
            {
                _binaries = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinariesObservably";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Binaries, "binaries");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Binaries, "binaries"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the intermediate response of the Echo Binaries Observably command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBinariesObservablyIntermediateDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.BinaryDto _binary;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBinariesObservablyIntermediateDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="binary">Single binary from the parameter list</param>
        public EchoBinariesObservablyIntermediateDto(System.IO.Stream binary, Tecan.Sila2.IBinaryStore store)
        {
            Binary = new Tecan.Sila2.BinaryDto(binary, store);
        }
        
        /// <summary>
        /// Single binary from the parameter list
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BinaryDto Binary
        {
            get
            {
                return _binary;
            }
            set
            {
                _binary = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Binary, "binary");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Binary, "binary"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Binaries Observably command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBinariesObservablyResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.BinaryDto _jointBinary;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBinariesObservablyResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="jointBinary">A single binary comprised of binaries received as parameter</param>
        public EchoBinariesObservablyResponseDto(System.IO.Stream jointBinary, Tecan.Sila2.IBinaryStore store)
        {
            JointBinary = new Tecan.Sila2.BinaryDto(jointBinary, store);
        }
        
        /// <summary>
        /// A single binary comprised of binaries received as parameter
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BinaryDto JointBinary
        {
            get
            {
                return _jointBinary;
            }
            set
            {
                _jointBinary = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(JointBinary, "jointBinary");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(JointBinary, "jointBinary"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Binary And Metadata String command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBinaryAndMetadataStringRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.BinaryDto _binary;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBinaryAndMetadataStringRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="binary">The binary to echo</param>
        public EchoBinaryAndMetadataStringRequestDto(System.IO.Stream binary, Tecan.Sila2.IBinaryStore store)
        {
            Binary = new Tecan.Sila2.BinaryDto(binary, store);
        }
        
        /// <summary>
        /// The binary to echo
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BinaryDto Binary
        {
            get
            {
                return _binary;
            }
            set
            {
                _binary = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryAndMetadataString";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Binary, "binary");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Binary, "binary"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Binary And Metadata String command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBinaryAndMetadataStringResponseDto : Tecan.Sila2.ISilaTransferObject<EchoBinaryAndMetadataStringResponse>
    {
        
        private Tecan.Sila2.BinaryDto _binary;
        
        private Tecan.Sila2.StringDto _stringMetadata;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public EchoBinaryAndMetadataStringResponseDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public EchoBinaryAndMetadataStringResponseDto(EchoBinaryAndMetadataStringResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            Binary = new Tecan.Sila2.BinaryDto(inner.Binary, store);
            StringMetadata = new Tecan.Sila2.StringDto(inner.StringMetadata, store);
        }
        
        /// <summary>
        /// The received binary
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BinaryDto Binary
        {
            get
            {
                return _binary;
            }
            set
            {
                _binary = value;
            }
        }
        
        /// <summary>
        /// The received String Metadata
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.StringDto StringMetadata
        {
            get
            {
                return _stringMetadata;
            }
            set
            {
                _stringMetadata = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public EchoBinaryAndMetadataStringResponse Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new EchoBinaryAndMetadataStringResponse(Binary.Extract(store), StringMetadata.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static EchoBinaryAndMetadataStringResponseDto Create(EchoBinaryAndMetadataStringResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            return new EchoBinaryAndMetadataStringResponseDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(Binary, "binary")) 
                        + Argument.Require(StringMetadata, "stringMetadata"));
        }
    }
}
